pipeline {
    agent any
    stages {

        stage('Test') {
            agent {
                docker { image 'php:latest'}
            }
            steps {
                sh "sudo apt-get update -yqq"
                sh "sudo apt-get install -yqq git libmcrypt-dev libpq-dev libcurl4-gnutls-dev libicu-dev libvpx-dev libjpeg-dev libpng-dev libxpm-dev zlib1g-dev libfreetype6-dev libxml2-dev libexpat1-dev libbz2-dev libgmp3-dev libldap2-dev unixodbc-dev libsqlite3-dev libaspell-dev libsnmp-dev libpcre3-dev libtidy-dev libzip-dev"
                sh "docker-php-ext-install zip xml"
                sh "curl -sS https://getcomposer.org/installer | php"
                sh "php composer.phar install"
                sh "sudo chmod 775 bin/phpunit"
                sh "bin/phpunit --coverage-text --colors=never --log-junit testReports.xml"
            }
            post {
                always {
                    junit testReports.xml
                }
            }
        }

        stage('Sonarcube analysis') {
            steps {
                sh 'docker run \
                        --rm \
                        -e SONAR_HOST_URL="http://vps821252.ovh.net:9000" \
                        -e SONAR_TOKEN="e41642460bb57724ce02f8fd5caf1bb2bf0fde18" \
                        -e SONAR_USER_HOME="${CI_PROJECT_DIR}/.sonar" \
                        -v ".:/usr/src" \
                        sonarsource/sonar-scanner-cli sonar-scanner  -Dsonar.qualitygate.wait=true'
            }
        }
    }
}